/*
 * Copyright (c) 2018-2999 广州亚米信息科技有限公司 All rights reserved.
 *
 * https://www.gz-yami.com/
 *
 * 未经允许，不可做商业用途！
 *
 * 版权所有，侵权必究！
 */

package com.yami.shop.security.api.config;

import com.yami.shop.security.comment.filter.YamiAuthenticationProcessingFilter;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Configuration;
import org.springframework.security.config.annotation.web.builders.HttpSecurity;
import org.springframework.security.config.http.SessionCreationPolicy;
import org.springframework.security.oauth2.config.annotation.web.configuration.EnableResourceServer;
import org.springframework.security.oauth2.config.annotation.web.configuration.ResourceServerConfigurerAdapter;
import org.springframework.security.web.authentication.UsernamePasswordAuthenticationFilter;

import java.util.List;

/**
 * @author LGH
 */
@Configuration
@EnableResourceServer
public class ResourceServerConfiguration extends ResourceServerConfigurerAdapter {

    @Autowired
    private List<YamiAuthenticationProcessingFilter> yamiAuthenticationProcessingFilters;

    @Override
    public void configure(HttpSecurity http) throws Exception {
        yamiAuthenticationProcessingFilters.forEach((yamiAuthenticationProcessingFilter)
                -> http.addFilterBefore(yamiAuthenticationProcessingFilter, UsernamePasswordAuthenticationFilter.class));

        http
                .sessionManagement().sessionCreationPolicy(SessionCreationPolicy.IF_REQUIRED)
                .and()

                .requestMatchers().anyRequest()
                .and()
                .anonymous()
                .and()

                .authorizeRequests()
                .antMatchers(
                        "/p/appointment/**",
                        "/p/order/**",
                        "/p/user/miniAppLogin",
                        "/p/prodComm/commList",
                        "/p/prodComm/commentCount",
                        "/popup/**"
                        ).permitAll()
                .and()

                .authorizeRequests()
                //配置/p访问控制，必须认证过后才可以访问
                .antMatchers("/p/**").authenticated();
    }
}
